# frozen_string_literal: true

# Copyright 2020 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     https://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# Auto-generated by gapic-generator-ruby. DO NOT EDIT!

require "gapic/common"
require "gapic/config"
require "gapic/config/method"

require "google/cloud/iot/v1/version"

require "google/cloud/iot/v1/device_manager/credentials"
require "google/cloud/iot/v1/device_manager/paths"
require "google/cloud/iot/v1/device_manager/client"

module Google
  module Cloud
    module Iot
      module V1
        ##
        # Internet of Things (IoT) service. Securely connect and manage IoT devices.
        #
        # To load this service and instantiate a client:
        #
        #     require "google/cloud/iot/v1/device_manager"
        #     client = ::Google::Cloud::Iot::V1::DeviceManager::Client.new
        #
        module DeviceManager
        end
      end
    end
  end
end

helper_path = ::File.join __dir__, "device_manager", "helpers.rb"
require "google/cloud/iot/v1/device_manager/helpers" if ::File.file? helper_path
